<template>
  <div class="koi-flex">
    <KoiCard>
      <el-form v-show="showSearch" ref="queryRef" :inline="true" :model="queryParams" label-width="68px">
        <el-form-item label="登录地址" prop="ipaddr">
          <el-input
            v-model="queryParams.ipaddr"
            clearable
            placeholder="请输入登录地址"
            style="width: 240px;"
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="用户名称" prop="userName">
          <el-input
            v-model="queryParams.userName"
            clearable
            placeholder="请输入用户名称"
            style="width: 240px;"
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-select
            v-model="queryParams.status"
            clearable
            placeholder="登录状态"
            style="width: 240px"
          >
            <el-option
              v-for="dict in koiDicts.sys_common_status"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="登录时间" style="width: 308px">
          <el-date-picker
            v-model="dateRange"
            end-placeholder="结束日期"
            range-separator="-"
            start-placeholder="开始日期"
            type="daterange"
            value-format="YYYY-MM-DD HH:mm:ss"
          ></el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button icon="Search" type="primary" @click="handleQuery">搜索</el-button>
          <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <el-row :gutter="10">
        <el-col :span="1.5">
          <el-button
            v-auth="['monitor:logininfor:remove']"
            :disabled="multiple"
            icon="Delete"
            plain
            type="danger"
            @click="handleDelete"
          >删除
          </el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            v-auth="['monitor:logininfor:remove']"
            icon="Delete"
            plain
            type="danger"
            @click="handleClean"
          >清空
          </el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            v-auth="['monitor:logininfor:unlock']"
            :disabled="single"
            icon="Unlock"
            plain
            type="primary"
            @click="handleUnlock"
          >解锁
          </el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            v-auth="['monitor:logininfor:export']"
            icon="Download"
            plain
            type="warning"
            @click="handleExport"
          >导出
          </el-button>
        </el-col>
        <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
      <div class="h-20px"></div>

      <el-table ref="logininforRef" v-loading="loading" :data="logininforList" :default-sort="defaultSort" border
                @selection-change="handleSelectionChange" @sort-change="handleSortChange">
        <el-table-column align="center" type="selection" width="55"/>
        <el-table-column align="center" label="访问编号" prop="infoId"/>
        <el-table-column :show-overflow-tooltip="true" :sort-orders="['descending', 'ascending']" align="center" label="用户名称"
                         prop="userName"
                         sortable="custom"/>
        <el-table-column :show-overflow-tooltip="true" align="center" label="地址" prop="ipaddr"/>
        <el-table-column :show-overflow-tooltip="true" align="center" label="登录地点" prop="loginLocation"/>
        <el-table-column :show-overflow-tooltip="true" align="center" label="操作系统" prop="os"/>
        <el-table-column :show-overflow-tooltip="true" align="center" label="浏览器" prop="browser"/>
        <el-table-column align="center" label="登录状态" prop="status">
          <template #default="scope">
            <KoiTag :tagOptions="koiDicts.sys_common_status" :value="scope.row.status"></KoiTag>
          </template>
        </el-table-column>
        <el-table-column :show-overflow-tooltip="true" align="center" label="描述" prop="msg"/>
        <el-table-column :sort-orders="['descending', 'ascending']" align="center" label="访问时间" prop="loginTime"
                         sortable="custom" width="180">
          <template #default="scope">
            <span>{{ parseTime(scope.row.loginTime) }}</span>
          </template>
        </el-table-column>
      </el-table>
      <div class="h-20px"></div>
      <!-- 分页 -->
      <Pagination :queryParams="queryParams" :total="total" :getList="getList" />
    </KoiCard>
  </div>
</template>

<script name="logininfor" setup>
import {ref} from "vue";
import {cleanLogininfor, delLogininfor, list, unlockLogininfor} from "@/api/system/loginlog/loginInfo.js";
import {useKoiDict} from "@/hooks/dicts/index.js";
import {koiMsgBox, koiNoticeSuccess} from "@/utils/koi.js";
import {download} from "@/utils/request.ts";

const {koiDicts} = useKoiDict(["sys_common_status"]);

const logininforList = ref([]);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const selectName = ref("");
const total = ref(0);
const dateRange = ref([]);
const defaultSort = ref({prop: "loginTime", order: "descending"});

// 查询参数
const queryParams = ref({
  pageNum: 1,
  pageSize: 15,
  ipaddr: undefined,
  userName: undefined,
  status: undefined,
  orderByColumn: undefined,
  isAsc: undefined
});

/** 查询登录日志列表 */
function getList() {
  loading.value = true;
  list(queryParams.value, dateRange.value).then(response => {
    logininforList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

const logininforRef = ref()

/** 重置按钮操作 */
function resetQuery() {
  dateRange.value = [];
  queryParams.value = {
    pageNum: 1,
    pageSize: 15,
    ipaddr: undefined,
    userName: undefined,
    status: undefined,
    orderByColumn: undefined,
    isAsc: undefined
  }
  logininforRef.value?.sort(defaultSort.value.prop, defaultSort.value.order);
}

/** 多选框选中数据 */
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.infoId);
  multiple.value = !selection.length;
  single.value = selection.length != 1;
  selectName.value = selection.map(item => item.userName);
}

/** 排序触发事件 */
function handleSortChange(column, prop, order) {
  queryParams.value.orderByColumn = column.prop;
  queryParams.value.isAsc = column.order;
  getList();
}

/** 删除按钮操作 */
function handleDelete(row) {
  const infoIds = row.infoId || ids.value;
  koiMsgBox('是否确认删除访问编号为"' + infoIds + '"的数据项?')
    .then(async () => {
      return delLogininfor(infoIds);
    }).then(() => {
    getList();
    koiNoticeSuccess("删除成功");
  })
    .catch(() => {
    });
}

/** 清空按钮操作 */
function handleClean() {
  koiMsgBox("是否确认清空所有登录日志数据项?？")
    .then(async () => {
      return cleanLogininfor();
    }).then(() => {
    getList();
    koiNoticeSuccess("删除成功");
  })
    .catch(() => {
    });
}

/** 解锁按钮操作 */
function handleUnlock() {
  const username = selectName.value;
  koiMsgBox('是否确认解锁用户"' + username + '"数据项?')
    .then(async () => {
      return unlockLogininfor(username);
    }).then(() => {
    koiNoticeSuccess("用户" + username + "解锁成功");
  })
    .catch(() => {
    });
}

/** 导出按钮操作 */
function handleExport() {
  download("monitor/logininfor/export", {
    ...queryParams.value,
  }, `logininfor_${new Date().getTime()}.xlsx`);
}

getList();
</script>
